using Insight.Infrastructure;
using Insight.Infrastructure.Entities;
using Insight.Web.Components.Containers;
using Insight.Web.Constants;
using Microsoft.AspNetCore.Components;
using MongoDB.Bson;
using MongoDB.Bson.Serialization;
using MongoDB.Bson.Serialization.Attributes;
using MongoDB.Driver;
using MudBlazor;
using System.Text.RegularExpressions;
using SortDirection = MudBlazor.SortDirection;

namespace Insight.Web.Pages.Inventory.Systems.Volumes;

[Route(Navigation.Inventory.Systems.Volumes.Index)]
public partial class Index
{
    [Inject] private IMongoDatabase Database { get; init; } = default!;
    [Inject] private ISnackbar Snackbar { get; init; } = default!;

    private TableContainer<ViewModel>? Container { get; set; }
    private string Title { get; set; } = Global.Name;
    private List<BreadcrumbItem> Breadcrumbs { get; } = new();
    private string? Search { get; set; }

    protected override void OnInitialized()
    {
        Title = $"Inventory » Volumes｜Insight";
        Breadcrumbs.Add(new BreadcrumbItem("Home", href: Navigation.Home));
        Breadcrumbs.Add(new BreadcrumbItem("Inventory", href: "#", true));
        Breadcrumbs.Add(new BreadcrumbItem("Volumes", href: "#", true));
    }

    private async Task<TableData<ViewModel>> LoadDataAsync(TableState state)
    {
        try
        {
            var search = Builders<BsonDocument>.Filter.Empty;

            if (string.IsNullOrWhiteSpace(Search) is false)
            {
                var regex = new BsonRegularExpression(new Regex(Search, RegexOptions.IgnoreCase));
                search &= Builders<BsonDocument>.Filter.Regex("host.name", regex) |
                    Builders<BsonDocument>.Filter.Regex("customer.name", regex) |
                    Builders<BsonDocument>.Filter.Regex("name", regex) |
                    Builders<BsonDocument>.Filter.Regex("type", regex) |
                    Builders<BsonDocument>.Filter.Regex("filesystem", regex);
            }

            var query = Database.HostVolume()
                .Aggregate()
                .Match(Builders<HostVolumeEntity>.Filter.Ne(p => p.FreeSpace, null))
                .Lookup("host", "_host", "_id", "hosts")
                .Match(new BsonDocument("hosts", new BsonDocument
                {
                    { "$exists", true },
                    { "$ne", new BsonArray() }
                }))
                .AppendStage<BsonDocument>(new BsonDocument("$addFields", new BsonDocument
                {
                    { "host", new BsonDocument("$first", "$hosts") }
                }))
                .AppendStage<BsonDocument>(new BsonDocument("$lookup", new BsonDocument
                {
                    { "from", "customer" },
                    { "localField", "host._customer" },
                    { "foreignField", "_id" },
                    { "as", "customers" }
                }))
                .AppendStage<BsonDocument>(new BsonDocument("$addFields", new BsonDocument
                {
                    { "customer", new BsonDocument("$first", "$customers") }
                }))
                .Match(search)
                .Sort(state.SortDirection switch
                {
                    SortDirection.Ascending => state.SortLabel switch
                    {
                        "Host" => Builders<BsonDocument>.Sort.Ascending("host.name"),
                        "Customer" => Builders<BsonDocument>.Sort.Ascending("customer.name"),
                        "Name" => Builders<BsonDocument>.Sort.Ascending("name"),
                        "Type" => Builders<BsonDocument>.Sort.Ascending("type"),
                        "Filesystem" => Builders<BsonDocument>.Sort.Ascending("filesystem"),
                        "Size" => Builders<BsonDocument>.Sort.Ascending("size"),
                        "Freespace" => Builders<BsonDocument>.Sort.Ascending("freespace"),
                        _ => null
                    },
                    SortDirection.Descending => state.SortLabel switch
                    {
                        "Host" => Builders<BsonDocument>.Sort.Descending("host.name"),
                        "Customer" => Builders<BsonDocument>.Sort.Descending("customer.name"),
                        "Name" => Builders<BsonDocument>.Sort.Descending("name"),
                        "Type" => Builders<BsonDocument>.Sort.Descending("type"),
                        "Filesystem" => Builders<BsonDocument>.Sort.Descending("filesystem"),
                        "Size" => Builders<BsonDocument>.Sort.Descending("size"),
                        "Freespace" => Builders<BsonDocument>.Sort.Descending("freespace"),
                        _ => null
                    },
                    _ => Builders<BsonDocument>.Sort.Ascending("freespace")
                });

            var countResult = await query.Count().FirstOrDefaultAsync(default);
            var itemResult = await query.Skip(state.Page * state.PageSize).Limit(state.PageSize).ToListAsync(default);

            return new TableData<ViewModel>()
            {
                TotalItems = countResult is null ? 0 : (int)countResult.Count,
                Items = itemResult.Select(x => BsonSerializer.Deserialize<ViewModel>(x))
            };
        }
        catch (Exception)
        {
            Notification.Error(Snackbar);
            return new TableData<ViewModel>();
        }
    }

    [BsonIgnoreExtraElements]
    public class ViewModel
    {
        [BsonId]
        public ObjectId? Id { get; set; }

        [BsonElement("host")]
        public HostEntity? Host { get; set; }

        [BsonElement("customer")]
        public CustomerEntity? Customer { get; set; }

        [BsonElement("name")]
        public string? Name { get; set; }

        [BsonElement("type")]
        public string? Type { get; set; }

        [BsonElement("filesystem")]
        public string? Filesystem { get; set; }

        [BsonElement("size")]
        public long? Size { get; set; }

        [BsonElement("freespace")]
        public long? Freespace { get; set; }
    }
}